#include <stdio.h>
#include "intlist.h"

// helper function: part still to reverse, part already reversed
intlist_t rev2(intlist_t todo, intlist_t done)
{
  return isempty(todo) ? done :
    rev2(tail(todo), cons(head(todo), done));
}

// 1-arg function for list reversal
intlist_t rev(intlist_t lst) { return rev2(lst, empty());  }

void printlist(intlist_t lst)
{
  if (isempty(lst)) putchar('\n');
  else { printf("%d ", head(lst)); printlist(tail(lst)); }
}

//////////////
// mergesort: TODO: fill in split & merge
/////////////


// structure for pair of two lists
typedef struct { intlist_t l1, l2; } lstpair_t;

// split list in two: 
lstpair_t split(intlist_t lst)
{
  lstpair_t p;
  // TODO: alternate placing elements of lst into in p.l1 or l.p2 
  return p;
}


intlist_t merge(intlist_t l1, intlist_t l2)
{
  // TODO: place min. of l1 and l2 first, recursively merge rest
}

// sort = split + sort parts (recursively) + merge
intlist_t sort(intlist_t lst)
{
  if (isempty(lst) || isempty(tail(lst))) return lst; // base: 0 or 1 element
  lstpair_t p = split(lst);
  return merge(sort(p.l1), sort(p.l2));
}

int main(void)
{
  intlist_t lst = cons(3, cons(2, cons(7, cons(4, empty()))));
  intlist_t r = rev(lst);
  printlist(r);
  return 0;
}
