#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define LEN	80
#define INCR	20

typedef int (*cmpfn_t)(const void *, const void *);

int cmp(const char **p1, const char **p2)
{
  return strcmp(*p1, *p2);
}

int main(void)
{
  char **b = NULL, **tmp;
  unsigned size = 0, cnt = 0;
  for (;; ++cnt) {
    if (cnt == size)
      if ((tmp = realloc(b, (size += INCR) * sizeof(char *)))) b = tmp;
      else break;
    if (!(b[cnt] = malloc(LEN))) break;
    if (!fgets(b[cnt], LEN, stdin)) { free(b[cnt]); break; }
  }
  if (b) {	// at least something usable
    qsort(b, cnt, sizeof(char *), (cmpfn_t)cmp);
    for (int i = 0; i < cnt; ++i)
      fputs(b[i], stdout);
  }
  return 0;
  
}
