#include <stdio.h>

/* Write a function that takes an unsigned n and returns the value obtained 
   by considering each base-10 digit as hexadecimal digit.
   f(1457)=0x1457. Use bitwise operators. */

unsigned bcd(unsigned n)
{
  // if one digit, done; else put conversion of other digits (n/10) before last
  return n < 10 ? n : bcd(n/10) << 4 | n % 10;
}

int main(void)
{
  printf("0x%x\n", bcd(1457));
  return 0;
}
