#include <stdio.h>

int main(void)
{
  int n = 0xCAFEBABE;

  // print out the number in hexadecimal
  printf("number in hex: %x", n);

  printf("\nsigned bytes: ");
  // print out the bytes, from least to most significant
  // loop while address less than address of next int in memory, &n + 1
  for (char *p = (char *)&n; p < (char *)(&n + 1); ++p)	// cast for warnings
    // char is signed, with bit 7 set (> 127) are converted to negative int
    printf("%x ", *p);
  
  printf("\nunsigned bytes: ");
  // use unsigned char to obtain nonnegative (unsigned) byte values
  for (unsigned char *p = (unsigned char *)&n; p < (unsigned char *)(&n + 1); ++p)
    printf("%x ", *p);
  putchar('\n');
  return 0;
}
