#include <stdio.h>

/* Write a function that checks if all nibbles of an unsigned have
   nondecreasing values from most to least significant.
   f(0x6AD)=1, f(0x243)=0. Use bitwise operators. */

int ordnib(unsigned n)
{
  // get least significant nibble, shift to remove it; done if 0 remaining
  for (unsigned crt, last = n & 0xF; n >>= 4; last = crt)
    if (last < (crt = n & 0xF)) return 0;	// compare with current nibble
  return 1;
}

int main(void)
{
  printf("%d\n", ordnib(0x6AD));
  return 0;
}